KhensysTest/Models/Permisos.cs
namespace KhensysTest.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;

    public partial class Permisos
    {
        public int Id { get; set; }

        [Required(ErrorMessage = "Debe ingresar el Nombre")]
        [StringLength(50)]
        public string NombreEmpleado { get; set; }

        [Required(ErrorMessage = "Debe ingresar el Apellido")]
        [StringLength(50)]
        public string ApellidosEmpleado { get; set; }

        public int TipoPermiso { get; set; }

        [Required(ErrorMessage = "Debe ingresar una Fecha")]
        public DateTime FechaPermiso { get; set; }

        public virtual TipoPermiso TipoPermisos { get; set; }
    }
}

KhensysTest/Models/PermisosContext.cs
namespace KhensysTest.Models
{
    using System;
    using System.Data.Entity;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Linq;

    public partial class PermisosContext : DbContext
    {
        public PermisosContext()
            : base("name=PermisosContext")
        {
        }

        public virtual DbSet<Permisos> Permisos { get; set; }      
        public virtual DbSet<TipoPermiso> TipoPermiso { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Entity<TipoPermiso>()
                .HasMany(e => e.Permisos)
                .WithRequired(e => e.TipoPermisos)
                .HasForeignKey(e => e.TipoPermiso)
                .WillCascadeOnDelete(false);
        }
    }
}

KhensysTest/Models/TipoPermiso.cs
namespace KhensysTest.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;

   
    public partial class TipoPermiso
    {       
        public TipoPermiso()
        {
            Permisos = new HashSet<Permisos>();
        }

      
        public int Id { get; set; }

        [Required]
        [StringLength(50)]
        public string Descripcion { get; set; }
       
        public virtual ICollection<Permisos> Permisos { get; set; }
    }
}

KhensysTest/Models/sysdiagrams.cs
namespace KhensysTest.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;

    public partial class sysdiagrams
    {
        [Required]
        [StringLength(128)]
        public string name { get; set; }

        public int principal_id { get; set; }

        [Key]
        public int diagram_id { get; set; }

        public int? version { get; set; }

        public byte[] definition { get; set; }
    }
}

KhensysTest/Controllers/PermisosController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Threading.Tasks;
using System.Net;
using System.Web;
using System.Web.Mvc;
using KhensysTest.Models;
using KhensysTest.Services;

namespace KhensysTest.Controllers
{
    public class PermisosController : Controller
    {
        
        private PermisosContext db = new PermisosContext();
        private readonly IPermisos _permisos;

        public PermisosController(IPermisos permisos)
        {
            _permisos = permisos;
        }


        // GET: Permisos
        [HttpGet]
        public ActionResult Index()
        {
            return View( _permisos.GetPermisos());
        }


       // GET: Permisos/Create
        public ActionResult Create()
        {
            ViewBag.TipoPermiso = new SelectList(db.TipoPermiso, "Id", "Descripcion");
            return View();
        }


        // POST: Permisos/Create      
        [HttpPost]
        public ActionResult Create(Permisos permisos)
        {
            if (ModelState.IsValid)
            {
                _permisos.CreatePermisos(permisos);
                             
                return RedirectToAction("Index");
            }

            ViewBag.TipoPermiso = new SelectList(db.TipoPermiso, "Id", "Descripcion", permisos.TipoPermiso);
            return View(permisos);
        }

        [HttpPost]
        public async Task<ActionResult> Delete(int id)
        {
           await _permisos.DeletePermisos(id);
            return View();
        }







        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

KhensysTest/Views/Permisos/Create.cshtml
@model KhensysTest.Models.Permisos

@{
    ViewBag.Title = "Solicitar Permiso";
}

<h2>Solicitar Permiso</h2>


@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
      
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            <label class="control-label col-md-2">Nombre </label>
            <div class="col-md-10">
                @Html.EditorFor(model => model.NombreEmpleado, new { htmlAttributes = new { @class = "form-control", required = "true" } })
                @Html.ValidationMessageFor(model => model.NombreEmpleado, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-2">Apellidos </label>
            <div class="col-md-10">
                @Html.EditorFor(model => model.ApellidosEmpleado, new { htmlAttributes = new { @class = "form-control", required = "true" } })
                @Html.ValidationMessageFor(model => model.ApellidosEmpleado, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-2"> Tipo Permiso  </label>
            <div class="col-md-10">
                @Html.DropDownList("TipoPermiso", null, htmlAttributes: new { @class = "form-control" , required = "true" })
                @Html.ValidationMessageFor(model => model.TipoPermiso, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <label class = "control-label col-md-2" >Fecha Permiso </label> 
            <div class="col-md-10">
                @Html.EditorFor(model => model.FechaPermiso, new { htmlAttributes = new { @class = "form-control", required = "true" } })
                @Html.ValidationMessageFor(model => model.FechaPermiso, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-success" />
            </div>
        </div>
    </div>
}


@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

KhensysTest/Views/Permisos/Delete.cshtml
@model KhensysTest.Models.Permisos

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Permisos</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.TipoPermisos.Descripcion)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.TipoPermisos.Descripcion)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NombreEmpleado)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NombreEmpleado)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ApellidosEmpleado)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ApellidosEmpleado)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.FechaPermiso)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.FechaPermiso)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

KhensysTest/Views/Permisos/Index.cshtml
@model IEnumerable<KhensysTest.Models.Permisos>

@{
    ViewBag.Title = "Index";
}

<h2>Ver Permisos</h2>


<table class="table">
    <tr>
        <th>
            Tipo Permiso
        </th>
        <th>
            Nombre Empleado
        </th>
        <th>
            Apellidos Empleado
        </th>
        <th>
            Fecha Permiso
        </th>
        <th></th>
    </tr>

    @foreach (var item in Model)
    {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.TipoPermisos.Descripcion)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.NombreEmpleado)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.ApellidosEmpleado)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.FechaPermiso)
            </td>
            <td>
                <button type="button" class="btn btn-warning" data-id="@item.Id" data-toggle="modal" data-target="#exampleModal">
                    Eliminar
                </button>
                
            </td>
        </tr>
    }

</table>

<!-- Modal -->
<div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel"></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
               <h4>Esta seguro de eliminar el registro?</h4>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>               
                <input type="button" id="EliminarPermiso" value="Eliminar" class="btn btn-danger" />
                
            </div>
        </div>
    </div>
</div>


<script type="text/javascript">

    var idPermiso;

    $('#EliminarPermiso').click(function () {
        $.ajax({
            type: "POST",
            url: "/Permisos/Delete",
            datatype: "json",
            data: { id: idPermiso },
            success: function (result) {
                location.reload();
            }
        })
    });

    $('#exampleModal').on('show.bs.modal', function (event) {
        var button = $(event.relatedTarget) // Button that triggered the modal
        idPermiso = button.data('id') // Extract info from data-* attributes
        // If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
        // Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
       
    })



</script>

KhensysTest/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/modernizr")
</head>
<body>
    <div class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
            
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li>@Html.ActionLink("Ver Permisos", "Index", "Permisos")</li>
                    <li>@Html.ActionLink("Solicitar Permiso", "Create", "Permisos")</li>
                </ul>
            </div>
        </div>
    </div>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer></footer>
    </div>

  
    @Scripts.Render("~/bundles/bootstrap")

    @RenderSection("scripts", required: false)
   
</body>
</html>